diff --git a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
index d37c4bc33..aaede56bb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -2,9 +2,12 @@ package net.minecraft.client.render;
 
 import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.render.entity.MobRendererPlayer;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.CompareFunc;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Materials;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.model.BlockModel;
@@ -13,72 +16,54 @@ import net.minecraft.client.render.entity.EntityRenderer;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
-import org.lwjgl.opengl.GL12;
+import org.joml.Math;
 
-import static org.lwjgl.opengl.GL11.GL_ALPHA_TEST;
-import static org.lwjgl.opengl.GL11.GL_BLEND;
-import static org.lwjgl.opengl.GL11.GL_DEPTH_TEST;
-import static org.lwjgl.opengl.GL11.glColor4f;
-import static org.lwjgl.opengl.GL11.glDisable;
-import static org.lwjgl.opengl.GL11.glEnable;
-import static org.lwjgl.opengl.GL11.glPopMatrix;
-import static org.lwjgl.opengl.GL11.glPushMatrix;
+public class ItemRenderer {
 
-public class ItemRenderer
-{
-
-    public ItemRenderer(Minecraft minecraft)
-    {
-        itemToRender = null;
-        height = 0.0F;
-        oHeight = 0.0F;
-        lastSlot = -1;
-        mc = minecraft;
+    public ItemRenderer(Minecraft minecraft) {
+        this.itemToRender = null;
+        this.height = 0.0F;
+        this.oHeight = 0.0F;
+        this.lastSlot = -1;
+        this.mc = minecraft;
     }
-    public float getEquippedProgress(float partialTick){
-        return oHeight + (height - oHeight) * partialTick;
+
+    public float getEquippedProgress(float partialTick) {
+        return this.oHeight + (this.height - this.oHeight) * partialTick;
     }
 
-    public void renderItemInFirstPerson(float partialTick)
-    {
+    public void renderItemInFirstPerson(float partialTick) {
         float equipProgress = getEquippedProgress(partialTick);
-        PlayerLocal player = mc.thePlayer;
+        PlayerLocal player = this.mc.thePlayer;
         float rotationPitch = player.xRotO + (player.xRot - player.xRotO) * partialTick;
-        GL11.glPushMatrix();
-        GL11.glRotatef(rotationPitch, 1.0F, 0.0F, 0.0F);
-        GL11.glRotatef(player.yRotO + (player.yRot - player.yRotO) * partialTick, 0.0F, 1.0F, 0.0F);
         Lighting.enableLight();
-        GL11.glPopMatrix();
-        ItemStack itemstack = itemToRender;
-        if(itemstack != null)
-        {
-            float brightness = 1.0f;
-            if(LightmapHelper.isLightmapEnabled() || mc.fullbright) {
-                LightmapHelper.setLightmapCoord(mc.thePlayer.getLightmap(partialTick));
-            }else {
-                brightness = mc.currentWorld.getLightBrightness(MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z));
-            }
-            ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderFirstPerson(Tessellator.instance, this,player, itemstack, brightness, 1f, partialTick);
+        GLRenderer.globalGetNormalTransformMatrix()
+            .rotateX(Math.toRadians(rotationPitch))
+            .rotateY(Math.toRadians(player.yRotO + (player.yRot - player.yRotO) * partialTick))
+            .invert();
+        ItemStack itemstack = this.itemToRender;
+        if (itemstack != null) {
+            GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+            GLRenderer.setLightmapCoord1i(this.mc.thePlayer.getLightmap(partialTick));
+            ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderFirstPerson(GLRenderer.getTessellator(), this, player, itemstack, player.getLightmap(partialTick), partialTick);
         } else {
 
-            GL11.glPushMatrix();
-            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        	float brightness = 1.0f;
-        	if(LightmapHelper.isLightmapEnabled() || mc.fullbright) {
-        		LightmapHelper.setLightmapCoord(mc.thePlayer.getLightmap(partialTick));
-        	}else if(mc.fullbright) {
-
-        	}else {
-        		brightness = mc.currentWorld.getLightBrightness(MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z));
-        	}
-            GL11.glColor4f(brightness, brightness, brightness, 1.0f);
-            EntityRenderer<? extends Entity> render = EntityRenderDispatcher.instance.getRenderer(mc.thePlayer);
-            MobRendererPlayer playerRenderer = (MobRendererPlayer)render;
+            GLRenderer.pushFrame();
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+            GLRenderer.enableState(State.DEPTH_TEST);
+            GLRenderer.setDepthFunc(CompareFunc.LESS);
+//            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+            float brightness = 1.0f;
+            GLRenderer.setLightmapCoord1i(this.mc.thePlayer.getLightmap(partialTick));
+            GLRenderer.setColor4f(brightness, brightness, brightness, 1.0f);
+            EntityRenderer<? extends Entity> render = EntityRendererDispatcher.instance.getRenderer(this.mc.thePlayer);
+            MobRendererPlayer playerRenderer = (MobRendererPlayer) render;
             if (player.getHeldObject() == null) {
                 if (player.isLeftHanded()) {
                     float f6 = 0.8F;
@@ -86,202 +71,191 @@ public class ItemRenderer
                     float f14 = MathHelper.sin(swingProgress * MathHelper.PI);
                     float f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
 
-                    GL11.glScalef(-1, 1, 1);
-                    GL11.glTranslatef(-f18 * 0.3F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.4F, -f14 * 0.4F);
-                    GL11.glTranslatef(0.8F * f6, -0.75F * f6 - (1.0F - equipProgress) * 0.6F, -0.9F * f6);
-                    GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
+                    GLRenderer.modelM4f().scale(-1, 1, 1);
+                    GLRenderer.modelM4f().translate(-f18 * 0.3F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.4F, -f14 * 0.4F);
+                    GLRenderer.modelM4f().translate(0.8F * f6, -0.75F * f6 - (1.0F - equipProgress) * 0.6F, -0.9F * f6);
+                    GLRenderer.modelM4f().rotateY(Math.toRadians(45F));
                     f14 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
                     f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
 
-                    GL11.glRotatef(f18 * 70F, 0.0F, 1.0F, 0.0F);
-                    GL11.glRotatef(-f14 * 20F, 0.0F, 0.0F, 1.0F);
-                    mc.textureManager.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), mc.thePlayer.slimModel ? PlayerSkinParser.instanceAlex : PlayerSkinParser.instanceSteve);
+                    GLRenderer.modelM4f().rotateY(Math.toRadians(f18 * 70F));
+                    GLRenderer.modelM4f().rotateZ(Math.toRadians(-f14 * 20F));
+                    this.mc.textureManager.bindDownloadableTexture(this.mc.thePlayer.skinURL, this.mc.thePlayer.getEntityTexture(), this.mc.thePlayer.slimModel ? PlayerSkinParser.instanceAlex : PlayerSkinParser.instanceSteve);
 
-                    GL11.glTranslatef(-1F, 3.6F, 3.5F);
-                    GL11.glRotatef(120F, 0.0F, 0.0F, 1.0F);
-                    GL11.glRotatef(200F, 1.0F, 0.0F, 0.0F);
-                    GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
-                    GL11.glTranslatef(5.6F, 0.0F, 0.0F);
+                    GLRenderer.modelM4f().translate(-1F, 3.6F, 3.5F);
+                    GLRenderer.modelM4f().rotateZ(Math.toRadians(120F));
+                    GLRenderer.modelM4f().rotateX(Math.toRadians(200F));
+                    GLRenderer.modelM4f().rotateY(Math.toRadians(-135F));
+                    GLRenderer.modelM4f().translate(5.6F, 0.0F, 0.0F);
 
-                    GL11.glPushMatrix();
-                    GL11.glScalef(-1, 1, 1);
-                    GL11.glPushMatrix();
-                    GL11.glScalef(1/16f, 1/16f, -1/16f);
-                    GL11.glTranslatef(0, 16, 0);
-                    GL11.glRotatef(180, 1, 0, 0);
-                    GL11.glTranslatef(0, -16, 0);
-                    GL11.glTranslatef(0, 8, 0);
-                    playerRenderer.drawFirstPersonHand(Tessellator.instance, mc.thePlayer, true);
-                    GL11.glPopMatrix();
-                    GL11.glPopMatrix();
+                    GLRenderer.pushFrame();
+                    GLRenderer.modelM4f().scale(-1, 1, 1);
+                    GLRenderer.modelM4f().scale(1 / 16f, 1 / 16f, -1 / 16f);
+                    GLRenderer.modelM4f().translate(0, 16, 0);
+                    GLRenderer.modelM4f().rotateX(Math.toRadians(180));
+                    GLRenderer.modelM4f().translate(0, -16, 0);
+                    GLRenderer.modelM4f().translate(0, 8, 0);
+                    playerRenderer.drawFirstPersonHand(GLRenderer.getTessellator(), this.mc.thePlayer, true);
+                    GLRenderer.popFrame();
                 } else {
                     float f6 = 0.8F;
                     float swingProgress = player.getSwingProgress(partialTick);
                     float f14 = MathHelper.sin(swingProgress * MathHelper.PI);
                     float f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
-                    GL11.glTranslatef(-f18 * 0.3F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.4F, -f14 * 0.4F);
-                    GL11.glTranslatef(0.8F * f6, -0.75F * f6 - (1.0F - equipProgress) * 0.6F, -0.9F * f6);
-                    GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
+                    GLRenderer.modelM4f().translate(-f18 * 0.3F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.4F, -f14 * 0.4F);
+                    GLRenderer.modelM4f().translate(0.8F * f6, -0.75F * f6 - (1.0F - equipProgress) * 0.6F, -0.9F * f6);
+                    GLRenderer.modelM4f().rotateY(Math.toRadians(45F));
                     f14 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
                     f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
-                    GL11.glRotatef(f18 * 70F, 0.0F, 1.0F, 0.0F);
-                    GL11.glRotatef(-f14 * 20F, 0.0F, 0.0F, 1.0F);
-                    mc.textureManager.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), mc.thePlayer.slimModel ? PlayerSkinParser.instanceAlex : PlayerSkinParser.instanceSteve);
-                    GL11.glTranslatef(-1F, 3.6F, 3.5F);
-                    GL11.glRotatef(120F, 0.0F, 0.0F, 1.0F);
-                    GL11.glRotatef(200F, 1.0F, 0.0F, 0.0F);
-                    GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
-                    GL11.glTranslatef(5.6F, 0.0F, 0.0F);
-                    GL11.glPushMatrix();
-                    GL11.glScalef(1/16f, 1/16f, -1/16f);
-                    GL11.glTranslatef(0, 16, 0);
-                    GL11.glRotatef(180, 1, 0, 0);
-                    GL11.glTranslatef(0, -16, 0);
-                    GL11.glTranslatef(0, 8, 0);
-                    playerRenderer.drawFirstPersonHand(Tessellator.instance, mc.thePlayer, false);
-                    GL11.glPopMatrix();
+                    GLRenderer.modelM4f().rotateY(Math.toRadians(f18 * 70F));
+                    GLRenderer.modelM4f().rotateZ(Math.toRadians(-f14 * 20F));
+                    this.mc.textureManager.bindDownloadableTexture(this.mc.thePlayer.skinURL, this.mc.thePlayer.getEntityTexture(), this.mc.thePlayer.slimModel ? PlayerSkinParser.instanceAlex : PlayerSkinParser.instanceSteve);
+                    GLRenderer.modelM4f().translate(-1F, 3.6F, 3.5F);
+                    GLRenderer.modelM4f().rotateZ(Math.toRadians(120F));
+                    GLRenderer.modelM4f().rotateX(Math.toRadians(200F));
+                    GLRenderer.modelM4f().rotateY(Math.toRadians(-135F));
+                    GLRenderer.modelM4f().translate(5.6F, 0.0F, 0.0F);
+                    GLRenderer.pushFrame();
+                    GLRenderer.modelM4f().scale(1 / 16f, 1 / 16f, -1 / 16f);
+                    GLRenderer.modelM4f().translate(0, 16, 0);
+                    GLRenderer.modelM4f().rotateX(Math.toRadians(180));
+                    GLRenderer.modelM4f().translate(0, -16, 0);
+                    GLRenderer.modelM4f().translate(0, 8, 0);
+                    playerRenderer.drawFirstPersonHand(GLRenderer.getTessellator(), this.mc.thePlayer, false);
+                    GLRenderer.popFrame();
                 }
             } else {
-                GL11.glPushMatrix();
+                GLRenderer.pushFrame();
                 float swingProgress = player.getSwingProgress(partialTick);
-                GL11.glTranslatef(0, MathHelper.sin(swingProgress * MathHelper.PI * 2 - MathHelper.PI/2)/33f, 0); // Bounces the held object up on swing
-                GL11.glScalef(1, -1f, 1); // Flips y axis because entities are flipped vertically ig
-                GL11.glRotatef(-MathHelper.sin(swingProgress * MathHelper.PI * 2) * 5f, 1, 0, 0); // Slightly rotates the object when swung
-                playerRenderer.drawHeldObject(mc.thePlayer, partialTick);
-                GL11.glPopMatrix();
+                GLRenderer.modelM4f().translate(0, MathHelper.sin(swingProgress * MathHelper.PI * 2 - MathHelper.PI / 2) / 33f, 0); // Bounces the held object up on swing
+                GLRenderer.modelM4f().scale(1, -1f, 1); // Flips y axis because entities are flipped vertically ig
+                GLRenderer.modelM4f().rotateX(Math.toRadians(-MathHelper.sin(swingProgress * MathHelper.PI * 2) * 5f)); // Slightly rotates the object when swung
+                playerRenderer.drawHeldObject(this.mc.thePlayer, partialTick);
+                GLRenderer.popFrame();
             }
-            GL11.glPopMatrix();
-            GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+            GLRenderer.popFrame();
+//            GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         }
         Lighting.disable();
     }
 
-	public void renderOverlays(float partialTicks) {
-    	glDisable(GL_DEPTH_TEST);
-		glDisable(GL_ALPHA_TEST);
-		
-		if(mc.thePlayer.isOnFire()) {
-            TextureRegistry.blockAtlas.bind();
-			renderFireInFirstPerson(partialTicks);
-		}
-		
-		if(mc.thePlayer.isInWall() && !mc.thePlayer.noPhysics) {
-			int blockX = MathHelper.floor(mc.thePlayer.x);
-			int blockY = MathHelper.floor(mc.thePlayer.y);
-			int blockZ = MathHelper.floor(mc.thePlayer.z);
+    public void renderOverlays(float partialTicks) {
+        GLRenderer.disableState(State.DEPTH_TEST);
+//        glDisable(GL_ALPHA_TEST);
 
-            TextureRegistry.blockAtlas.bind();
-			
-			int id = mc.currentWorld.getBlockId(blockX, blockY, blockZ);
-            int meta = mc.currentWorld.getBlockMetadata(blockX, blockY, blockZ);
+        if (this.mc.thePlayer.isOnFire()) {
+            TextureRegistry.worldAtlas.bind();
+            renderFireInFirstPerson(partialTicks);
+        }
+
+        if (this.mc.thePlayer.isInWall() && !this.mc.thePlayer.noPhysics) {
+            int blockX = MathHelper.floor(this.mc.thePlayer.x);
+            int blockY = MathHelper.floor(this.mc.thePlayer.y);
+            int blockZ = MathHelper.floor(this.mc.thePlayer.z);
+
+            TextureRegistry.worldAtlas.bind();
+
+            int id = this.mc.currentWorld.getBlockId(blockX, blockY, blockZ);
+            int meta = this.mc.currentWorld.getBlockMetadata(blockX, blockY, blockZ);
             Block<?> block = Blocks.blocksList[id];
             BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(block);
-			if(mc.currentWorld.isBlockNormalCube(blockX, blockY, blockZ)) {
-				renderInsideOfBlock(partialTicks, model.getOverlayTexture(meta));
-			} else {
+            if (this.mc.currentWorld.isBlockNormalCube(blockX, blockY, blockZ)) {
+                renderInsideOfBlock(partialTicks, model.getOverlayTexture(meta));
+            } else {
                 id = 0;
-				for (int i = 0; i < 8; i++) {
-					float x0 = ((float) ((i >> 0) % 2) - 0.5F) * mc.thePlayer.bbWidth * 0.9F;
-					float y0 = ((float) ((i >> 1) % 2) - 0.5F) * mc.thePlayer.bbHeight * 0.2F;
-					float z0 = ((float) ((i >> 2) % 2) - 0.5F) * mc.thePlayer.bbWidth * 0.9F;
-					
-					int x1 = MathHelper.floor_float(blockX + x0);
-					int y1 = MathHelper.floor_float(blockY + y0);
-					int z1 = MathHelper.floor_float(blockZ + z0);
-					
-					if(mc.currentWorld.isBlockNormalCube(x1, y1, z1)) {
-						id = mc.currentWorld.getBlockId(x1, y1, z1);
-                        meta = mc.currentWorld.getBlockMetadata(x1, y1, z1);
+                for (int i = 0; i < 8; i++) {
+                    float x0 = ((float) ((i >> 0) % 2) - 0.5F) * this.mc.thePlayer.bbWidth * 0.9F;
+                    float y0 = ((float) ((i >> 1) % 2) - 0.5F) * this.mc.thePlayer.bbHeight * 0.2F;
+                    float z0 = ((float) ((i >> 2) % 2) - 0.5F) * this.mc.thePlayer.bbWidth * 0.9F;
+
+                    int x1 = MathHelper.floor_float(blockX + x0);
+                    int y1 = MathHelper.floor_float(blockY + y0);
+                    int z1 = MathHelper.floor_float(blockZ + z0);
+
+                    if (this.mc.currentWorld.isBlockNormalCube(x1, y1, z1)) {
+                        id = this.mc.currentWorld.getBlockId(x1, y1, z1);
+                        meta = this.mc.currentWorld.getBlockMetadata(x1, y1, z1);
                         break;
-					}
-				}
-                if(Blocks.blocksList[id] != null) {
+                    }
+                }
+                if (Blocks.blocksList[id] != null) {
                     model = BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[id]);
                     renderInsideOfBlock(partialTicks, model.getOverlayTexture(meta));
                 }
-			}
-
-		}
-		if(mc.thePlayer.isUnderLiquid(Materials.WATER)) {
-            mc.textureManager.loadTexture("/assets/minecraft/textures/misc/water.png").bind();
-			renderWarpedTextureOverlay(partialTicks);
-		}
-		glEnable(GL_ALPHA_TEST);
-		glEnable(GL_DEPTH_TEST);
-	}
+            }
+        }
+        if (this.mc.thePlayer.isUnderLiquid(Materials.WATER)) {
+            this.mc.textureManager.loadTexture("/assets/minecraft/textures/misc/water.png").bind();
+            renderWarpedTextureOverlay(partialTicks);
+        }
+//        glEnable(GL_ALPHA_TEST);
+        GLRenderer.enableState(State.DEPTH_TEST);
+    }
 
-	private void renderInsideOfBlock(float partialTicks, IconCoordinate texture) {
+    private void renderInsideOfBlock(float partialTicks, IconCoordinate texture) {
         if (texture == null) return;
-		Tessellator tessellator = Tessellator.instance;
-		
-		float brightness = 0.1f;
-		if(mc.fullbright) {
-			brightness = 1.0f;
-		}
-		glColor4f(brightness, brightness, brightness, 0.5f);
-		glPushMatrix();
-		
-		final float x0 = -1F;
-		final float x1 = 1.0F;
-		final float y0 = -1F;
-		final float y1 = 1.0F;
-		
-		final float z = -0.5F;
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
+
+        float brightness = 0.1f;
+        if (this.mc.fullbright) {
+            brightness = 1.0f;
+        }
+        GLRenderer.pushFrame();
+        GLRenderer.setColor4f(brightness, brightness, brightness, 0.5f);
+        final float x0 = -1F;
+        final float x1 = 1.0F;
+        final float y0 = -1F;
+        final float y1 = 1.0F;
+
+        final float z = -0.5F;
 
         float u0 = (float) texture.getIconUMin();
-		float v0 = (float) texture.getIconVMin();
-		float u1 = (float) texture.getIconUMax();
-		float v1 = (float) texture.getIconVMax();
-		
-		tessellator.startDrawingQuads();
-		tessellator.addVertexWithUV(x0, y0, z, u1, v1);
-		tessellator.addVertexWithUV(x1, y0, z, u0, v1);
-		tessellator.addVertexWithUV(x1, y1, z, u0, v0);
-		tessellator.addVertexWithUV(x0, y1, z, u1, v0);
-		tessellator.draw();
-		
-		glPopMatrix();
-		glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
-	}
+        float v0 = (float) texture.getIconVMin();
+        float u1 = (float) texture.getIconUMax();
+        float v1 = (float) texture.getIconVMax();
+
+        tessellator.startDrawingQuads();
+        tessellator.addVertexWithUV(x0, y0, z, u1, v1);
+        tessellator.addVertexWithUV(x1, y0, z, u0, v1);
+        tessellator.addVertexWithUV(x1, y1, z, u0, v0);
+        tessellator.addVertexWithUV(x0, y1, z, u1, v0);
+        tessellator.draw();
+        GLRenderer.popFrame();
+    }
 
-    private void renderWarpedTextureOverlay(float f)
-    {
-        Tessellator tessellator = Tessellator.instance;
-        float f1 = mc.thePlayer.getBrightness(f);
-        if (mc.fullbright) f1 = 1.0f;
-        GL11.glColor4f(f1, f1, f1, 0.5F);
-        GL11.glEnable(GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glPushMatrix();
+    private void renderWarpedTextureOverlay(float f) {
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        float f1 = this.mc.thePlayer.getBrightness(f);
+        if (this.mc.fullbright) f1 = 1.0f;
+        GLRenderer.setColor4f(f1, f1, f1, 0.5F);
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         float f2 = 4F;
         float f3 = -1F;
         float f4 = 1.0F;
         float f5 = -1F;
         float f6 = 1.0F;
         float f7 = -0.5F;
-        float f8 = -mc.thePlayer.yRot / 64F;
-        float f9 = mc.thePlayer.xRot / 64F;
+        float f8 = -this.mc.thePlayer.yRot / 64F;
+        float f9 = this.mc.thePlayer.xRot / 64F;
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(f3, f5, f7, f2 + f8, f2 + f9);
         tessellator.addVertexWithUV(f4, f5, f7, 0.0F + f8, f2 + f9);
         tessellator.addVertexWithUV(f4, f6, f7, 0.0F + f8, 0.0F + f9);
         tessellator.addVertexWithUV(f3, f6, f7, f2 + f8, 0.0F + f9);
         tessellator.draw();
-        GL11.glPopMatrix();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glDisable(GL_BLEND);
+        GLRenderer.popFrame();
     }
 
-    private void renderFireInFirstPerson(float f)
-    {
-        Tessellator tessellator = Tessellator.instance;
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.85F);
-        GL11.glEnable(GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+    private void renderFireInFirstPerson(float f) {
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 0.85F);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         float scale = 1.5f;
-        for(int i = 0; i < 2; i++)
-        {
-            GL11.glPushMatrix();
+        for (int i = 0; i < 2; i++) {
+            GLRenderer.pushFrame();
             IconCoordinate texture = TextureRegistry.getTexture("minecraft:block/fire");
             float uMin = (float) texture.getIconUMin();
             float uMax = (float) texture.getIconUMax();
@@ -292,58 +266,51 @@ public class ItemRenderer
             float yMin = 0.0F - scale / 2.0F;
             float yMax = yMin + scale;
             float f10 = -0.5F;
-            GL11.glTranslatef((float)(-(i * 2 - 1)) * 0.4F, -0.3F, 0.0F);
-            GL11.glRotatef((float)(i * 2 - 1) * 10F, 0.0F, 1.0F, 0.0F);
+            GLRenderer.modelM4f().translate((float) (-(i * 2 - 1)) * 0.4F, -0.3F, 0.0F);
+            GLRenderer.modelM4f().rotateY(Math.toRadians((float) (i * 2 - 1) * 10F));
             tessellator.startDrawingQuads();
             tessellator.addVertexWithUV(xMin, yMin - 0.5, f10, uMax, vMax);
             tessellator.addVertexWithUV(xMax, yMin - 0.5, f10, uMin, vMax);
             tessellator.addVertexWithUV(xMax, yMax, f10, uMin, vMin);
             tessellator.addVertexWithUV(xMin, yMax, f10, uMax, vMin);
             tessellator.draw();
-            GL11.glPopMatrix();
+            GLRenderer.popFrame();
         }
 
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        GL11.glDisable(GL11.GL_BLEND);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.disableState(State.BLEND);
     }
 
-    public void updateEquippedItem()
-    {
-        oHeight = height;
-        PlayerLocal entityplayersp = mc.thePlayer;
-        ItemStack itemstack = entityplayersp.inventory.getCurrentItem();
-        boolean flag = lastSlot == entityplayersp.inventory.getCurrentItemIndex() && itemstack == itemToRender;
-        if(itemToRender == null && itemstack == null)
-        {
+    public void updateEquippedItem() {
+        this.oHeight = this.height;
+        PlayerLocal playerLocal = this.mc.thePlayer;
+        ItemStack itemstack = playerLocal.inventory.getCurrentItem();
+        boolean flag = this.lastSlot == playerLocal.inventory.getCurrentItemIndex() && itemstack == this.itemToRender;
+        if (this.itemToRender == null && itemstack == null) {
             flag = true;
         }
-        if(itemstack != null && itemToRender != null && itemstack != itemToRender && itemstack.itemID == itemToRender.itemID && itemstack.getMetadata() == itemToRender.getMetadata())
-        {
-            itemToRender = itemstack;
+        if (itemstack != null && this.itemToRender != null && itemstack != this.itemToRender && itemstack.itemID == this.itemToRender.itemID && itemstack.getMetadata() == this.itemToRender.getMetadata()) {
+            this.itemToRender = itemstack;
             flag = true;
         }
         float f = 0.4F;
         float f1 = flag ? 1.0F : 0.0F;
-        float f2 = f1 - height;
-        if(f2 < -f)
-        {
+        float f2 = f1 - this.height;
+        if (f2 < -f) {
             f2 = -f;
         }
-        if(f2 > f)
-        {
+        if (f2 > f) {
             f2 = f;
         }
-        height += f2;
-        if(height < 0.1F)
-        {
-            itemToRender = itemstack;
-            lastSlot = entityplayersp.inventory.getCurrentItemIndex();
+        this.height += f2;
+        if (this.height < 0.1F) {
+            this.itemToRender = itemstack;
+            this.lastSlot = playerLocal.inventory.getCurrentItemIndex();
         }
     }
 
-    public void resetEquippedProgress()
-    {
-        height = 0.0F;
+    public void resetEquippedProgress() {
+        this.height = 0.0F;
     }
 
     private final Minecraft mc;
